<?php
/*
 * Generic PHP script to perform a REST request
 * on the BaseX HTTP server
 * Can do any REST request required, but typical use is
 * to provide a .xq file to be executed 
 * plus additional parameters needed for the .xq file
 * For example: ....?run=fulltext.xq&search=^P
 *
 * created by Paul Swennenhuis, paul@swennenhuis.nl
 */
 
 // PHP XML to JSON converter
 // used to convert BaseX XML results to JSON
include("XMLToJSON.class.php");


// get time in microseconds
function microtime_float() {
    list($usec, $sec) = explode(" ", microtime());
    return ((float)$usec + (float)$sec);
}

 
try {
	   
  try {
  	// track the duration of the request (will be included in the result)
  	$start = microtime_float();
  	// BaseX credentials
  	$username = "paolo";
    $password = "a33445";

	// Create a stream, an include a basic authorization header in it
	$opts = array(
	  'http'=>array(
	    'method' => "GET",
	    'header' => "Authorization: Basic " . base64_encode("$username:$password")                 
	  )
	);
	$context = stream_context_create($opts);

	// Open the request using the HTTP headers set above

    $result = file_get_contents(sprintf("http://localhost:8984/rest?%s", $_SERVER['QUERY_STRING']), FALSE, $context);
	// var_dump($result);
	 // convert to JSON
    $xj = new XmlToJson();
    $result = $xj->Parse($result);
    $time = ( microtime_float() - $start) * 1000;
    // include the duration in tne JSON result 
    $final = (object)array("time"=>$time, "results"=>json_decode($result));
	// output the result, in JSONP format, i.e. including a callback  
    print ($_GET['callback'] . '('.json_encode($final).')');
   
  } catch (Exception $e) {
    // print exception
    print $e->getMessage();
  }
 
} catch (Exception $e) {
  // print exception
  print $e->getMessage();
}
?>